'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _unionClassNames = require('union-class-names');

var _unionClassNames2 = _interopRequireDefault(_unionClassNames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var LineCounter = function (_Component) {
  _inherits(LineCounter, _Component);

  function LineCounter() {
    _classCallCheck(this, LineCounter);

    return _possibleConstructorReturn(this, (LineCounter.__proto__ || Object.getPrototypeOf(LineCounter)).apply(this, arguments));
  }

  _createClass(LineCounter, [{
    key: 'getLineCount',
    value: function getLineCount(editorState) {
      var blockArray = editorState.getCurrentContent().getBlocksAsArray();
      return blockArray ? blockArray.length : null;
    }
  }, {
    key: 'getClassNames',
    value: function getClassNames(count, limit) {
      var _props = this.props,
          _props$theme = _props.theme,
          theme = _props$theme === undefined ? {} : _props$theme,
          className = _props.className;

      var defaultStyle = (0, _unionClassNames2.default)(theme.counter, className);
      var overLimitStyle = (0, _unionClassNames2.default)(theme.counterOverLimit, className);
      return count > limit ? overLimitStyle : defaultStyle;
    }
  }, {
    key: 'render',
    value: function render() {
      var _props2 = this.props,
          store = _props2.store,
          limit = _props2.limit;

      var count = this.getLineCount(store.getEditorState());
      var classNames = this.getClassNames(count, limit);

      return _react2.default.createElement(
        'span',
        { className: classNames },
        count
      );
    }
  }]);

  return LineCounter;
}(_react.Component);

LineCounter.propTypes = {
  theme: _propTypes2.default.any,
  limit: _propTypes2.default.number
};
exports.default = LineCounter;